from mpu9250_i2c import *
from math import sqrt, atan2, pi, copysign, sin, cos

time.sleep(1) # delay necessary to allow mpu9250 to settle

def low_pass_filter(raw_value:float, remembered_value):
    ''' Only applied 20% of the raw value to the filtered value s'''
    
    # global filtered_value
    alpha = 0.8
    filtered = 0
    filtered = (alpha * remembered_value) + (1.0 - alpha) * raw_value
    return filtered


print('recording data')
while True:
    filtered_x_value = 0
    filtered_y_value = 0
    try:
        ax,ay,az,wx,wy,wz = mpu6050_conv() # read and convert mpu6050 data
        mx,my,mz = AK8963_conv() # read and convert AK8963 magnetometer data
    except:
        continue
    
    # Pitch and Roll in Radians
    roll_rad = atan2(-ax, sqrt((az*az)+(ay*ay)))
    pitch_rad = atan2(az, copysign(ay,ay)*sqrt((0.01*ax*ax)+(ay*ay)))

    # Pitch and Roll in Degrees
    pitch = pitch_rad*180/pi
    roll = roll_rad*180/pi  

    # Get soft_iron adjusted values from the magnetometer
    filtered_x_value = low_pass_filter(mx, filtered_x_value)
    filtered_y_value = low_pass_filter(my, filtered_y_value)
    heading =  90 - atan2(filtered_y_value, filtered_x_value) * 180 / pi

    """print('{}'.format('-'*30))
    print('accel [g]: x = {0:2.2f}, y = {1:2.2f}, z {2:2.2f}= '.format(ax,ay,az))
    print('gyro [dps]:  x = {0:2.2f}, y = {1:2.2f}, z = {2:2.2f}'.format(wx,wy,wz))
    print('mag [uT]:   x = {0:2.2f}, y = {1:2.2f}, z = {2:2.2f}'.format(mx,my,mz))
    print('{}'.format('-'*30))"""
    print("pitch = ",pitch, "roll = ",roll,"heading = ",heading)
   
    time.sleep(1)